--Health and Armour Regeneration Script v1.3 by: mman0385

local regen = {}
local healthtimer = 0
local armourtimer = 0
local lastarmour = 0
local lasthealth = 0
local curarmour = PED.GET_PED_ARMOUR
local maxarmour = PLAYER.GET_PLAYER_MAX_ARMOUR
local addarmour = PED.ADD_ARMOUR_TO_PED
local curhealth = ENTITY.GET_ENTITY_HEALTH
local maxhealth = ENTITY.GET_ENTITY_MAX_HEALTH
local sethealth = ENTITY.SET_ENTITY_HEALTH
local getpedID = PLAYER.PLAYER_PED_ID
local getplayerID = PLAYER.GET_PLAYER_PED
local doesexist = ENTITY.DOES_ENTITY_EXIST

function regen.tick()

	local playerID = getpedID()
	local player = getplayerID(playerID)
	
	if doesexist(playerID) then
	--print(PED.GET_PED_ARMOUR(playerID))
		if curarmour(playerID) < maxarmour(player) then
			healthtimer = 0
			if lastarmour == curarmour(playerID) then
				if lasthealth == curhealth(playerID) then
					armourtimer = armourtimer+1
					if armourtimer > 1199 then						--Initial delay before armour starts to regenerate
						addarmour(playerID, 5)			--Armour regen amount. Must be an integer(+1,+2,+3 etc.)
						lastarmour = curarmour(playerID)
						armourtimer = 1100							--Armour regen rate. 1200 = instant
					end
					else
					lasthealth = curhealth(playerID)
					armourtimer = 0
				end
				else
				lastarmour = curarmour(playerID)
				armourtimer = 0
			end
			else
			armourtimer = 0
			if curhealth(playerID) < maxhealth(playerID) then
				healthtimer = healthtimer+1
				if healthtimer > 199 then							--Health regen rate
					sethealth(playerID, curhealth(playerID)+1)	--Health regen amount. Must be an integer
					healthtimer = 0
				end
				else
				healthtimer = 0
			end
		end
	end
end
return regen